<template>
  <div class="edit-project">
    <form @submit.prevent="submit">
      <div class="form-field search-user">
        <div class="col-12 md:col-4">
          <div class="p-inputgroup">
            <prime-auto-complete
              v-model="userInput"
              placeholder="Введите email"
              field="email"
              :suggestions="usersSuggestions"
              @complete="searchUsersByEmail($event.query)"
            />
            <prime-button
              type="submit"
              label="Добавить"
            />
          </div>
        </div>
      </div>
    </form>

    <div>
      <div
        v-for="user in sharedUsers"
        :key="user.id"
        class="shared-user"
      >
        <span class="shared-user__email">{{ user.user.email }}</span>
        <prime-button
          icon="pi pi-times"
          class="p-button-rounded p-button-danger p-button-text p-button-sm"
          @click="deleteSharedUser(user)"
        />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import PrimeAutoComplete from 'primevue/autocomplete/AutoComplete.vue';
import PrimeButton from 'primevue/button/Button.vue';
import { defineComponent, PropType } from 'vue';
import { addSharedUser, deleteSharedUsersByProject, getSharedUsersByProject, searchUserByEmail } from '@/api/handler/user';
import { Project } from '@/models/projects';
import { SharedUser } from '@/models/user';

interface User {
  id: number;
  email: string;
}

interface Data {
  userInput: null | User;
  sharedUsers: SharedUser[];
  usersSuggestions: User[];
}

export default defineComponent({
  name: 'share-project-with-user',
  components: {
    PrimeAutoComplete,
    PrimeButton,
  },
  props: {
    project: { type: Object as PropType<Project>, required: true },
  },
  emits: ['close', 'add-user'],
  data(): Data {
    return {
      userInput: null,
      usersSuggestions: [],
      sharedUsers: [],
    };
  },
  async created() {
    const res = await getSharedUsersByProject({ projectId: this.project.id });

    if (res.__state === 'success') {
      this.sharedUsers = res.data;
    }
  },
  methods: {
    async submit() {
      if (this.userInput === null) {
        return;
      }
      const res = await addSharedUser({ projectId: this.project.id, userId: this.userInput.id });
      if (res.__state === 'success') {
        this.sharedUsers.push(res.data);
        this.userInput = null;
      }
    },
    async searchUsersByEmail(email: string) {
      const res = await searchUserByEmail({ email });

      if (res.__state === 'success') {
        this.usersSuggestions = res.data;
      }
    },
    async deleteSharedUser(sharedUser: SharedUser) {
      const res = await deleteSharedUsersByProject({ projectId: this.project.id, sharedUserId: sharedUser.id });

      if (res.__state === 'success') {
        const index = this.sharedUsers.findIndex(sharedUserItem => sharedUser.id === sharedUserItem.id);

        if (index === -1) {
          return;
        }

        this.sharedUsers.splice(index, 1);
      }
    },
  },
});
</script>

<style lang="scss" scoped>
.edit-project {
  width: 25rem;
}

.p-field * {
  display: block;
}

.shared-user {
    display: flex;
    align-items: center;

    &__email {
        flex: 1 1 auto;
    }
}
</style>
